--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **             "Ukady programowalne CoolRunner II w praktyce"          **
-- **                                                                      **
-- **    Project name: Clock                                               **
-- **    Module: BCDCorr                                                   **
-- **    Target device: CoolRunner II (XC2C256/Q144)                       **
-- **    Tool versions: ISE WebPACK 9.2i                                   **
-- **    Date: BIAYSTOK, stycze 2009                                     **
-- **                                                                      **
-- **                     Napisa : Andrzej Pawluczuk                      **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
---------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

entity BCDCorr is port ( BCDIn : in std_logic_vector ( 3 downto 0 ) ;
                         BCDOut : out std_logic_vector ( 3 downto 0 ) ) ;
end BCDCorr ;

architecture Behavioral of BCDCorr is

begin
  with BCDIn select
    BCDOut <= "0010" when "1111" ,
              "0001" when "1110" ,
              "0000" when "1101" ,
              "1111" when "1100" ,
              "1110" when "1011" ,
              "1101" when "1010" ,
              "1100" when "1001" ,
              "1011" when "1000" ,
              "1010" when "0111" ,
              "1001" when "0110" ,
              "1000" when "0101" ,
              "0100" when "0100" ,
              "0011" when "0011" ,
              "0010" when "0010" ,
              "0001" when "0001" ,
              "0000" when others ;

end Behavioral ;
